/***************************************************************************
                          sqmixer.h  -  description
                             -------------------
    begin                : Sat Apr  6 22:43:57 CEST 2002
    copyright            : (C) 2002 by Sven Queisser
    email                : svenqueisser@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SQMIXER_H
#define SQMIXER_H

#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qsettings.h>

#include "sqmixerhw.h"

class SQMixerApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    /** construtor */
    SQMixerApp();
    /** destructor */
    ~SQMixerApp();
    /** initializes all QActions of the application */
    void initActions();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();

    /** overloaded for Message box on last window exit */
    bool queryExit();

  public slots:

    /** exits the application */
    void slotFileQuit();

    /** shows an about dlg*/
    void slotHelpAbout();

    /* enable / disable timer */
    void setTimer( bool );

    /* read / wrie config file: */
    void saveConf();
    void loadConf();

    void setUseMute( bool );
    void setUseRec( bool );
    void setUseVol( bool );

  private:
    QPopupMenu *fileMenu;
    QPopupMenu *viewMenu;
    QPopupMenu *helpMenu;
    QPopupMenu *settingsMenu;

    QAction *fileQuit;
    QAction *viewStatusBar;
    QAction *autoUpdate;
    QAction *helpAboutApp;
    QAction *menuLoadConf;
    QAction *menuSaveConf;
    QAction *menuUseVol;
    QAction *menuUseRec;
    QAction *menuUseMute;

    QTimer *counter;

    mchannel **channels;
    QAction **viewchannels;

    bool useVol;
    bool useRec;
    bool useMute;

    bool configIsValid;

	signals:
	void recsChanged();     /* emitted by channel if recording source changed */
	void allChanged();      /* emitted if values changed outside the mixer */		

};
#endif 

