/***************************************************************************
                          sqmixerhw.h  -  description
                             -------------------
    begin                : Tue Apr 9 2002
    copyright            : (C) 2002 by Sven Queisser
    email                : svenqueisser@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SQMIXERHW_H
#define SQMIXERHW_H

#include <sys/soundcard.h>

#include <qobject.h>
#include <qwidget.h>
#include <qhbox.h>
#include <qcheckbox.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlineedit.h>


class fader : public QHBox{
    Q_OBJECT

    public:
    fader(QWidget *parent, const char *name);

    public slots:
    void setValue(int value);
    void valueChanges(int value);

    signals:
    void valueChanged(int);

    private:
    QSlider *slider;
    QLabel *disp;

};

class mchannel : public QHBox{
	Q_OBJECT			    /* integrate into QT */
	
	public:
	mchannel(QWidget *parent = 0, int SetChannel = -1);	/* init of channel: read current volume */
    QString getName();

    void setName( QString *name );

    bool getMuteState();
    bool getLockState();
    bool getRecState();

    int getLVolume();
    int getRVolume();
    int getLMuteVol();
    int getRMuteVol();

    void setLVolume( int val );
    void setRVolume( int val );
    void setLMuteVol( int val );
    void setRMuteVol( int val );

    void setMuteState( bool val );
    void setLockState( bool val );
    void setRecState( bool val );
    	
	public slots:
	void SetRVal(int value); /* set new volume, through QT */
	void SetLVal(int value); /* set new volume, through QT */
    void SetRec(int recval); /* get/set recording for this device */

    int  GetRVal();          /* get current value */
	int  GetLVal();          /* get current value */
    bool GetRec();

    void updateAll();
    void updateRecs();

    void enable(bool enable);/* show this channel or not */

    void enableMuting( bool enable );

    private:
    QCheckBox *checkRec;
    QCheckBox *checkLock;
    QCheckBox *checkMute;

//    QString *channelName;

//    QLabel *channelLabel;
//    QPushButton *channelLabel;
    QLineEdit *channelLabel;

    fader *lfader;
    fader *rfader;

	int channel;
		
	bool IsStereo;
	bool IsRecDev;
	
	int rvol;               /* right and left channel volume */
	int lvol;               /* right is ignored on mono devs */
	int lmute;              /* saved values */
	int rmute;

    signals:
    void recsChanged();
//    void enableView(int);
//    void disableView(int);

};

class smixer{
	private:
	
	public:

    struct mixer_info info;	/* mixer_info struct */

    int fd;				    /* fd for mixer device, set by mixer() */
	smixer(char *filename); /* constructor: do initialization */
	~smixer();		        /* destructor: remove all channels[] subclasses */
	int error;              /* status */
	
	/* bitmasks: */
	int devs;               /* all available devices */
	int rec;                /* recording devices */
	int st;                 /* stereo devices */
};


/* my little helpers */

/* void printbin(int)
 * print an integer number in binary
 */
void printbin(int value);

/* int countones(int)
 * count number of binary '1's in an integer
 */
int countones(int value);

#endif
